--local BS = AceLibrary("Babble-Spell-2.2");
--Example of BS usage for localization:
--[BS["Corruption"]] 
--[BS["Shadow Bolt"]]

--Spells learned at low levels have weird factors.. Formula anyone?

--Spells with additional effects, like a slowing effect, get a 5% penalty to damage and healing bonuses. This penalty is applied after the spell type calculation, before other penalties. For example, a standard area of effect spell with an slow effect would be calculated like so:
--((Cast Time of Spell / 3.5 ) * .95 Penalty for extra effect) / 3 = Benefit 
--Examples of these spells include: Entangling Roots (Druid), Mind Flay (Priest), Blast Wave (Mage) 

WarlockTable = {

	spellInfo = {
		["Corruption"] = {
					["0"] = { School = "Shadow", castTime = 2, eDot = true },
					["5"] = { bMin=486, bMax=486, eDuration = 18, },
					["6"] = { bMin=666, bMax=666, eDuration = 18, },
					["7"] = { bMin=822, bMax=822, eDuration = 18, }, 
				},
		["Shadow Bolt"] = {
					["0"] = { School = "Shadow", castTime = 3, canCrit = true, CastMod = 0.1, },
					["7"] = { bMin=281, bMax=315, },
					["8"] = { bMin=360, bMax=402, },
					["9"] = { bMin=455, bMax=507, },
					["10"] ={ bMin=482, bMax=538, },
					["11"] ={ bMin=541, bMax=603, },
				},
		["Curse of Agony"] = {
					["0"] = { School = "Shadow", eDot = true, },
					["5"] = { bMin=780, bMax=780, eDuration = 24, },
					["6"] = { bMin=1044, bMax=1044, eDuration = 24, },
					["7"] = { bMin=1356, bMax=1356, eDuration = 24, },
				},
		["Curse of Doom"] = {
					["0"] = { School = "Shadow", eDot = true, },
					["1"] = { bMin=3200, bMax=3200, eDuration = 60, },
					["2"] = { bMin=4200, bMax=4200, eDuration = 60, },
				},
		["Death Coil"] = {
					["0"] = { School = "Shadow", sFactor = 0.5, },
					["2"] = { bMin=319, bMax=319, eDuration = 2, },
					["3"] = { bMin=446, bMax=447, eDuration = 2, },
					["4"] = { bMin=519, bMax=519, eDuration = 2, },
				},
		["Drain Life"] = {
					["0"] = { School = "Shadow", castTime=5, sHits = 5, sFactor = 0.5, },
					["5"] = { bMin=55, bMax=55,  },
					["6"] = { bMin=71, bMax=71, },
					["7"] = { bMin=87, bMax=87,  },
					["8"] = { bMin=108, bMax=108,  },
				},
		["Drain Soul"] = { 
					["0"] = { School = "Shadow", castTime=15, sFactor = 0.5, },
					["4"] = { bMin=455, bMax=455, },
					["5"] = { bMin=620, bMax=620, },
				},
		["Siphon Life"] = {
					["0"] = { School = "Shadow", sHits = 10, eDot = true, sFactor = 0.5, },
					["4"] = { bMin=45, bMax=45, eDuration = 30 },
					["5"] = { bMin=52, bMax=52, eDuration = 30 },
					["6"] = { bMin=63, bMax=63, eDuration = 30 },
				},
		["Searing Pain"] = { 
					["0"] = { School = "Fire", canCrit = true, },
					["5"] = { bMin=158, bMax=188, },
					["6"] = { bMin=208, bMax=244, },
					["7"] = { bMin=243, bMax=287, },
					["8"] = { bMin=270, bMax=320, },
				},
		["Soul Fire"] = {
					["0"] = { School = "Fire", castTime=6, canCrit = true, CastMod = 0.4, },
					["1"] = { bMin=623, bMax=783, },
					["2"] = { bMin=715, bMax=894, },
					["3"] = { bMin=839, bMax=1051, },
					["4"] = { bMin=1003, bMax=1257, },
				},
		["Shadowburn"] = {
					["0"] = { School = "Shadow", canCrit = true, },
					["5"] = { bMin=350, bMax=392, },
					["6"] = { bMin=450, bMax=502, },
					["7"] = { bMin=518, bMax=578, },
					["8"] = { bMin=597, bMax=665, },
				},
		["Immolate"] = {
					["0"] = { School = "Fire", canCrit = true, castTime=2, CastMod = 0.1, sFactor = 0.349, },
					["5"] = { bMin=134, bMax=134, hybridDotDmg = 255, eDuration = 15, },
					["6"] = { bMin=192, bMax=192, hybridDotDmg = 365, eDuration = 15, },
					["7"] = { bMin=258, bMax=258, hybridDotDmg = 485, eDuration = 15, },
					["8"] = { bMin=279, bMax=279, hybridDotDmg = 510, eDuration = 15, },
					["9"] = { bMin=327, bMax=327, hybridDotDmg = 615, eDuration = 15, },
				},
		["Hellfire"] = {
					["0"] = { School = "Fire", castTime=15, sHits = 15, sFactor = 1/3, },
					["2"] = { bMin=139, bMax=139, },
					["3"] = { bMin=212, bMax=213, },
					["4"] = { bMin=306, bMax=306, },
				},
		["Rain of Fire"] = { 
					["0"] = { School = "Fire", castTime=8, sFactor = 1/3, },
					["3"] = { bMin=620, bMax=620, },
					["4"] = { bMin=908, bMax=912, },
					["5"] = { bMin=1212, bMax=1212, },
				},
		["Unstable Affliction"] = {
					["0"] = { School = "Shadow", eDot = true },
					["1"] = { bMin=660, bMax=660, eDuration = 18, },
					["2"] = { bMin=840, bMax=840, eDuration = 18, },
					["3"] = { bMin=1050, bMax=1050, eDuration = 18, },
				},
		["Conflagrate"] = { 
					["0"] = { School = "Fire", canCrit = true },
					["1"] = { bMin=240, bMax=306, },
					["2"] = { bMin=316, bMax=396, },
					["3"] = { bMin=383, bMax=479, },
					["4"] = { bMin=447, bMax=457, },
					["5"] = { bMin=512, bMax=638, },
					["6"] = { bMin=579, bMax=721, },
				},
	},	

 	talentInfo = {
		["Contagion"] = { Effect = 0.01, Spells = { "Curse of Agony", "Corruption", "Seed of Corruption" }, },
		["Shadow Mastery"] = { Effect = 0.02, Spells = { "Unstable Affliction", "Siphon Life", "Drain Life", "Drain Soul", "Shadowburn", "Shadow Bolt", "Corruption", "Curse of Agony" }, Spells2 = { "Death Coil" }, ModType2 = "SpellDamageBonus", },	
		["Improved Curse of Agony"] = { Effect = 0.05, Spells = { "Curse of Agony" }, },
		["Empowered Corruption"] = { Effect = 0.12, Spells = { "Corruption" }, ModType = "SpellDamage" },
		["Emberstorm"] = { Effect = 0.02, Spells = { "Searing Pain", "Immolate", "Soul Fire", "Hellfire", "Rain of Fire", "Incinerate", "Conflagrate" }, },
		["Improved Immolate"] = { Effect = 0.05, Spells = { "Immolate" }, ModType = "BaseNuke" },
		["Shadow and Flame"] = { Effect = 0.04, Spells = { "Shadow Bolt", "Incinerate" }, ModType = "SpellDamage" },
		["Bane"] = { Effect = 1, Spells = { "Shadow Bolt", "Immolate", "Soul Fire" }, ModType = "CastTime" },
		["Demonic Tactics"] = { Effect = 0.01, Spells = { "All" }, },
		["Improved Corruption"] = { Effect = 0.04, Spells = { "Corruption" }, ModType = "CastTime" },
		["Devastation"] = { Effect = 1, Spells = { "All" }, ModType = "Crit", },
		["Backlash"] = { Effect = 1, Spells = { "All" }, ModType = "Crit", },
		["Improved Searing Pain"] = { Effect = 10/3, Spells = { "Searing Pain" }, ModType = "Crit", },
		["Ruin"] = { Effect = 0.5, Spells = { "All" }, ModType = "CritMultiplier", },
		["Demonic Knowledge"] = { Effect = 0.05, Spells = { "All" }, ModType = "Special" },
		["Improved Shadow Bolt"] = { Effect = 0.05, Spells = { "Shadow Bolt" }, ModType = "Special" }
	},
}

MageTable = {

	spellInfo = { 
		["Pyroblast"] = {
					["0"] = { School = "Fire", castTime=6, canCrit = true, Ignite = true, },
					["5"] = { bMin=407, bMax=515, hybridDotDmg=156, eDuration=12, },
					["6"] = { bMin=503, bMax=631, hybridDotDmg=188, eDuration=12, },
					["7"] = { bMin=600, bMax=750, hybridDotDmg=228, eDuration=12, },
					["8"] = { bMin=708, bMax=898, hybridDotDmg=268, eDuration=12, },
					["9"] = { bMin=846, bMax=1074, hybridDotDmg=312, eDuration=12, },
				},
		["Fireball"] = {
					["0"] = { School = "Fire", canCrit = true, castTime=3.5, extraDotF = 0.02, CastMod = 0.1, Ignite = true, },
					["8"] = { bMin=318, bMax=414, extraDotDmg=40, eDuration=8, },
					["9"] = { bMin=392, bMax=506, extraDotDmg=52, eDuration=8, },
					["10"] = { bMin=475, bMax=609, extraDotDmg=60, eDuration=8, },
					["11"] = { bMin=561, bMax=715, extraDotDmg=72, eDuration=8, },
					["12"] = { bMin=596, bMax=760, extraDotDmg=76, eDuration=8, },
					["13"] = { bMin=633, bMax=805, extraDotDmg=84, eDuration=8, },
				},
		["Scorch"] = {
					["0"] = { School = "Fire", canCrit = true,  Ignite = true, },
					["4"] = { bMin=133, bMax=159, },
					["5"] = { bMin=162, bMax=192, },
					["6"] = { bMin=200, bMax=239, },
					["7"] = { bMin=233, bMax=275, },
					["8"] = { bMin=269, bMax=317, },
					["9"] = { bMin=305, bMax=361, },
				},
		["Fire Blast"] = {
					["0"] = { School = "Fire", canCrit = true, Ignite = true, },
					["5"] = { bMin=242, bMax=290, },
					["6"] = { bMin=332, bMax=394, },
					["7"] = { bMin=431, bMax=509, },
					["8"] = { bMin=539, bMax=637, },
					["9"] = { bMin=664, bMax=786, },
				},				
		["Blast Wave"] = {
					["0"] = { School = "Fire", canCrit = true, sFactor=0.95 * 1/3, Ignite = true, },
					["3"] = { bMin=277, bMax=329, },
					["4"] = { bMin=365, bMax=433, },
					["5"] = { bMin=462, bMax=544, },
					["6"] = { bMin=533, bMax=627, },
					["7"] = { bMin=616, bMax=724, },
				},
		["Dragon's Breath"] = {
					["0"] = { School = "Fire", canCrit = true, sFactor=0.95 * 1/3, Ignite = true, },
					["1"] = { bMin=370, bMax=430, },
					["2"] = { bMin=454, bMax=526, },
					["3"] = { bMin=574, bMax=666, },
					["4"] = { bMin=680, bMax=790, },
				},				
		--TODO: VERIFY FLAMESTRIKE
		["Flamestrike"] = {
					["0"] = { School = "Fire", castTime=3, canCrit = true, Ignite = true, sFactor = 1/3 * 0.95 * 0.7 },
					["4"] = { bMin=220, bMax=272, hybridDotDmg=192, eDuration=8, },
					["5"] = { bMin=291, bMax=359, hybridDotDmg=264, eDuration=8, },
					["6"] = { bMin=375, bMax=459, hybridDotDmg=340, eDuration=8, },
					["7"] = { bMin=471, bMax=575, hybridDotDmg=424, eDuration=8, },
				},				
		["Frostbolt"] = {
					["0"] = { School = "Frost", castTime=3, canCrit = true, CastMod = 0.1, sFactor=0.95, },
					["8"] = { bMin=292, bMax=316, eDuration=9, },
					["9"] = { bMin=353, bMax=383, eDuration=9, },
					["10"] = { bMin=429, bMax=463, eDuration=9, },
					["11"] = { bMin=515, bMax=555, eDuration=9, },
					["12"] = { bMin=522, bMax=562, eDuration=9, },
					["13"] = { bMin=597, bMax=643, eDuration=9, },
				},
		["Blizzard"] = {
					["0"] = { School = "Frost", castTime=8, sFactor= 1/3, },
					["4"] = { bMin=720, bMax=720, },
					["5"] = { bMin=936, bMax=936, },
					["6"] = { bMin=1192, bMax=1192, },
					["7"] = { bMin=1472, bMax=1472, },
				},
		["Cone of Cold"] = {
					["0"] = { School = "Frost", canCrit = true, sFactor= 0.895 * 1/3, },
					["3"] = { bMin=203, bMax=223, },
					["4"] = { bMin=264, bMax=290, },
					["5"] = { bMin=335, bMax=365, },
					["6"] = { bMin=410, bMax=448, },
				},
		["Frost Nova"] = {
					["0"] = { School = "Frost", canCrit = true, sFactor= 0.95 * 1/3, },
					["1"] = { bMin=19, bMax=21, sFactor = 0.075, },
					["2"] = { bMin=33, bMax=37, sFactor = 0.165, },
					["3"] = { bMin=47, bMax=53, sFactor = 0.2, },
					["4"] = { bMin=71, bMax=79, sFactor = 0.2, },
					["5"] = { bMin=99, bMax=111, sFactor = 0.2, },
				},				
		["Arcane Missiles"] = {
					["0"] = { School = "Arcane", castTime=5, sHits=5, },
					["5"] = { bMin=115, bMax=115, },
					["6"] = { bMin=151, bMax=151, },
					["7"] = { bMin=192, bMax=192, },
					["8"] = { bMin=230, bMax=230, },
					["9"] = { bMin=240, bMax=240, },
				},
		["Arcane Explosion"] = {
					["0"] = { School = "Arcane", canCrit = true, sFactor=1/3, },
					["1"] = { bMin=32, bMax =36, sFactor = 0.32 },
					["5"] = { bMin=186, bMax=202, },
					["6"] = { bMin=243, bMax=263, },
					["7"] = { bMin=306, bMax=330, },
					["8"] = { bMin=377, bMax=407, },
				},
		},
			
	talentInfo = { 
		--ARCANE:
		["Arcane Impact"] = { Effect = 2, Spells = { "Arcane Explosion", "Arcane Impact" }, ModType = "Crit", },
		["Arcane Instability"] = { Effect = 0.125, Spells = { "All" }, ModType = "CritMultiplier", },
		["Empowered Arcane Missiles"] = { Effect = 0.15, Spells = { "Arcane Missiles" }, ModType = "SpellDamage" },
		--FIRE:
		["Improved Fireball"] = { Effect = 1, Spells = { "Fireball" }, ModType = "CastTime" },
		["Ignite"] = { Effect = 0.08, Spells = { "Fireball", "Pyroblast", "Fire Blast", "Scorch", "Blast Wave", "Dragon's Breath", "Flamestrike" }, ModType = "Ignite" },
		["Improved Flamestrike"] = { Effect = 5, Spells = { "Flamestrike" }, ModType = "Crit", },
		["Critical Mass"] = { Effect = 2, Spells = { "Fireball", "Pyroblast", "Fire Blast", "Scorch", "Blast Wave", "Dragon's Breath", "Flamestrike" }, ModType = "Crit" },
		["Playing with Fire"] = { Effect = 0.01, Spells = { "All" }, },
		["Fire Power"] = { Effect = 0.02, Spells = { "Fireball", "Pyroblast", "Fire Blast", "Scorch", "Blast Wave", "Dragon's Breath", "Flamestrike" } },
		["Pyromaniac"] = { Effect = 1, Spells = { "Fireball", "Pyroblast", "Fire Blast", "Scorch", "Blast Wave", "Dragon's Breath", "Flamestrike" }, ModType = "Crit" },
		["Empowered Fireball"] = { Effect = 0.03, Spells = { "Fireball" }, ModType = "SpellDamage" },
		--FROST:
		["Improved Frostbolt"] = { Effect = 1, Spells = { "Frostbolt" }, ModType = "CastTime" },
		["Ice Shards"] = { Effect = 0.10, Spells = { "Frostbolt", "Cone of Cold", "Frost Nova" }, ModType = "CritMultiplier", },
		["Piercing Ice"] = { Effect = 0.02, Spells = { "Frostbolt", "Cone of Cold", "Blizzard", "Frost Nova", } },
		["Improved Cone of Cold"] = { Effect = 35/3, Spells = { "Cone of Cold" } },
		["Empowered Frostbolt"] = { Effect = 0.02, Spells = { "Frostbolt" }, ModType = "SpellDamage", Effect2 = 1, Spells2 = { "Frostbolt" }, ModType2 = "Crit" }, 
	},
}

PriestTable = {

	spellInfo = { },
	talentInfo = { },
}